unit unitfrmHaupt;

{$IFDEF FPC}
  {$mode objfpc}{$H+}
{$ENDIF}
{$IFDEF FPC_OBJFPC} {$DEFINE IS_FPC_OBJFPC_MODE} {$ENDIF}

interface

uses
  Classes, SysUtils, sqldb, odbcconn, sqlite3conn, db, process, FileUtil, Forms,
  Controls, Graphics, Dialogs, EditBtn, StdCtrls;

type

  { TfrmHaupt }

  TfrmHaupt = class(TForm)
    Button1: TButton;
    ComboBox_ODBC: TComboBox;
    DatasourceODBCAdressen: TDataSource;
    DatasourceODBCRechnung: TDataSource;
    DatasourceODBCArtikel: TDataSource;
    DataSource_Adressen: TDataSource;
    DataSource_Artikel: TDataSource;
    DataSource_RechnungDetail: TDataSource;
    DataSource_RechnungGlobal: TDataSource;
    Edit_RechnungAktuell: TEdit;
    Edit_AdressenGesamt: TEdit;
    Edit_AdresseAktuell: TEdit;
    Edit_ArtikelAktuell: TEdit;
    Edit_RechnungGesamt: TEdit;
    Edit_ArtikelGesamt: TEdit;
    FileNameEdit_SQLite: TFileNameEdit;
    FileNameEdit_ODBC: TFileNameEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Memo_Status: TMemo;
    ODBCConnection: TODBCConnection;
    SQLite3Connection: TSQLite3Connection;
    SQLQueryODBCAdressen: TSQLQuery;
    SQLQueryODBCRechnung: TSQLQuery;
    SQLQueryODBCArtikel: TSQLQuery;
    SQLQuery_Adressen: TSQLQuery;
    SQLQuery_Artikel: TSQLQuery;
    SQLQuery_RechnungDetail: TSQLQuery;
    SQLQuery_RechnungGlobal: TSQLQuery;
    SQLTransaction: TSQLTransaction;
    SQLTransactionODBC: TSQLTransaction;
    procedure Button1Click(Sender: TObject);
    procedure FileNameEdit_SQLiteChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure SQLQueryODBCAdressenAfterOpen(DataSet: TDataSet);
  private
    { private declarations }
  public
    { public declarations }
    procedure Text_von_DB_umwandeln(Sender: TField; var aText: string; DisplayText: BOOLEAN);
    procedure Text_nach_DB_umwandeln(Sender: TField; const aText: string);
  end;

var
  frmHaupt: TfrmHaupt;

implementation

{$R *.lfm}

{ TfrmHaupt }

procedure TfrmHaupt.Button1Click(Sender: TObject);
var
  i : integer;
  Datum : TDateTime;
  AdressenAktuell : integer;
  RechnungenAktuell : integer;
  IDAdresse : integer;
  IDRechnungGlobal : integer;
begin
   //DecimalSeparator:='.';

   if (FileNameEdit_ODBC.FileName = '') Or (FileNameEdit_SQLite.FileName='') then
      begin
        showmessage('Bitte wählen Sie die Datenbanken aus.');
        exit;
      end;

   Memo_Status.Text:='SQlite3_Datenbank:' + UTF8ToSys(FileNameEdit_SQLite.FileName) + chr(13) + Memo_Status.Text;
   Memo_Status.Text:='ODBC Datenbank:' + UTF8ToSys(FileNameEdit_ODBC.FileName) + chr(13) + Memo_Status.Text;

   Memo_Status.Text:='Starte ODBC Verbindung' + chr(13) + Memo_Status.Text;
   Memo_Status.Refresh;

   SQLite3Connection.DatabaseName:=UTF8ToSys(FileNameEdit_SQLite.FileName);

   SQLTransaction.DataBase:=SQLite3Connection;

   ODBCConnection.Driver:= Combobox_ODBC.Text;
   ODBCConnection.Params.Add('DBQ=' + UTF8ToSys(FileNameEdit_ODBC.FileName));
   ODBCConnection.Params.Add('AUTOCOMMIT=1');
   ODBCConnection.CharSet:='UTF8';

   ODBCConnection.Connected:= True;
   ODBCConnection.KeepConnection := True;

   SQLTransactionODBC.DataBase := ODBCConnection;
   SQLTransactionODBC.Action := caCommit;
   SQLTransactionODBC.Active := false; //not applied to ms access(false) bei true kommt fehler das die transaktion schon aktiv ist
   SQLTransactionODBC.StartTransaction;
   Memo_Status.Text:='ODBC Verbindung erfolgreich durchgeführt' + chr(13) + Memo_Status.Text;

   Memo_Status.Text:='Verbinde ODBC-Tabellen' + chr(13) + Memo_Status.Text;
   Memo_Status.Refresh;

   SQLQueryODBCAdressen.DataBase:=ODBCConnection;
   SQLQueryODBCAdressen.UsePrimaryKeyAsKey := False;
   SQLQueryODBCAdressen.UpdateMode:= upWhereAll;
   SQLQueryODBCAdressen.Filtered:=True;
   SQLQueryODBCAdressen.MaxIndexesCount:=100;
   SQLQueryODBCAdressen.SQL.Text := 'SELECT * FROM Adressen ORDER BY Name, Vorname';
   SQLQueryODBCAdressen.Open;
   DatasourceODBCAdressen.DataSet := SQLQueryODBCAdressen;

   Memo_Status.Text:='Tabelle Adressen verbunden' + chr(13) + Memo_Status.Text;
   Memo_Status.Refresh;

   SQLQueryODBCRechnung.DataBase:=ODBCConnection;
   SQLQueryODBCRechnung.UsePrimaryKeyAsKey := False;
   SQLQueryODBCRechnung.UpdateMode:= upWhereAll;
   SQLQueryODBCRechnung.Filtered:=True;
   SQLQueryODBCRechnung.MaxIndexesCount:=100;
   SQLQueryODBCRechnung.SQL.Text := 'SELECT * FROM Archiv_Rechnungen ORDER BY ID, Datum';
   SQLQueryODBCRechnung.Open;
   DatasourceODBCRechnung.DataSet := SQLQueryODBCRechnung;

   Memo_Status.Text:='Tabelle Archive_Rechnungen verbunden' + chr(13) + Memo_Status.Text;
   Memo_Status.Refresh;

   SQLQueryODBCArtikel.DataBase:=ODBCConnection;
   SQLQueryODBCArtikel.UsePrimaryKeyAsKey := False;
   SQLQueryODBCArtikel.UpdateMode:= upWhereAll;
   SQLQueryODBCArtikel.Filtered:=True;
   SQLQueryODBCArtikel.MaxIndexesCount:=100;
   SQLQueryODBCArtikel.SQL.Text := 'SELECT * FROM Artikel ORDER BY Artikel';
   SQLQueryODBCArtikel.Open;
   DatasourceODBCArtikel.DataSet := SQLQueryODBCArtikel;

   Memo_Status.Text:='Tabelle Artikel verbunden' + chr(13) + Memo_Status.Text;
   Memo_Status.Text:='ODBC-Tabellen erfolgreich verbunden' + chr(13) + Memo_Status.Text;
   Memo_Status.Text:='Starte SQlite3 Verbindung' + chr(13) + Memo_Status.Text;

   Memo_Status.Refresh;

   Memo_Status.Text:='SQlite3 Verbindung erfolgreich durchgeführt' + chr(13) + Memo_Status.Text;

   Memo_Status.Text:='Verbinde SQlite3 Tabellen' + chr(13) + Memo_Status.Text;

   Memo_Status.Refresh;

   SQLQuery_Adressen.Transaction:=SQLTransaction;
   SQLQuery_Adressen.SQL.Text:='SELECT * FROM tbAdressen ORDER BY ID';
   SQLQuery_Adressen.Open;
   SQLQuery_Adressen.Active:=true;

   SQLQuery_RechnungGlobal.Transaction:=SQLTransaction;
   SQLQuery_RechnungGlobal.SQL.Text:='SELECT * FROM tbRechnungGlobal ORDER BY ID';
   SQLQuery_RechnungGlobal.Open;
   SQLQuery_RechnungGlobal.Active:=true;

   SQLQuery_RechnungDetail.Transaction:=SQLTransaction;
   SQLQuery_RechnungDetail.SQL.Text:='SELECT * FROM tbRechnungPositionen ORDER BY ID';
   SQLQuery_RechnungDetail.Open;
   SQLQuery_RechnungDetail.Active:=true;

   SQLQuery_Artikel.Transaction:=SQLTransaction;
   SQLQuery_Artikel.SQL.Text:='SELECT * FROM tbArtikel ORDER BY ID';
   SQLQuery_Artikel.Open;
   SQLQuery_Artikel.Active:=true;

   Memo_Status.Text:='SQlite3 Tabellen verbunden' + chr(13) + Memo_Status.Text;
   SQLQueryODBCAdressen.Last;
   SQLQueryODBCAdressen.First;
   SQLQueryODBCRechnung.Last;
   SQLQueryODBCRechnung.First;
   SQLQueryODBCArtikel.Last;
   SQLQueryODBCArtikel.First;
   Edit_AdressenGesamt.Text:=IntToStr(SQLQueryODBCAdressen.RecordCount);
   Edit_AdressenGesamt.Refresh;
   Edit_RechnungGesamt.Text:=IntToStr(SQLQueryODBCRechnung.RecordCount);
   Edit_RechnungGesamt.Refresh;
   Edit_ArtikelGesamt.Text:=IntToStr(SQLQueryODBCArtikel.RecordCount);
   Edit_ArtikelGesamt.Refresh;

   Edit_AdresseAktuell.Text := '0';
   Edit_RechnungAktuell.Text := '0';
   Edit_ArtikelAktuell.Text := '0';

   Memo_Status.Text:='Starte Artikelverarbeitung.' + chr(13) + Memo_Status.Text;
   Memo_Status.Refresh;

   SQLQueryODBCAdressen.First;

   while SQLQueryODBCArtikel.EOF = false do
         begin
//           Memo_Status.Text:='Preis_Netto_Euro:' + SQLQueryODBCArtikel.FieldByName('Preis_Netto_Euro').AsString + chr(13) + Memo_Status.Text;
//           Memo_Status.Text:='Preis_Brutto_Euro:' + SQLQueryODBCArtikel.FieldByName('Preis_Brutto_Euro').AsString + chr(13) + Memo_Status.Text;
//           Memo_Status.Refresh;
           SQLQuery_Artikel.Append;
           SQLQuery_Artikel.FieldByName('Artikel').AsString:=UTF8Encode(SQLQueryODBCArtikel.FieldByName('Artikel').AsString);
           if SQLQueryODBCArtikel.FieldByName('Preis_Netto_Euro').IsNull = false then SQLQuery_Artikel.FieldByName('Preis_Netto').Value:=SQLQueryODBCArtikel.FieldByName('Preis_Netto_Euro').Value;
           if SQLQueryODBCArtikel.FieldByName('Preis_Brutto_Euro').IsNull = false then SQLQuery_Artikel.FieldByName('Preis_Brutto').Value:=SQLQueryODBCArtikel.FieldByName('Preis_Brutto_Euro').Value;
           if SQLQueryODBCArtikel.FieldByName('Einheit').IsNull = false then SQLQuery_Artikel.FieldByName('Einheit').AsString:=UTF8Encode(SQLQueryODBCArtikel.FieldByName('Einheit').Value);
           if SQLQueryODBCArtikel.FieldByName('Marke').IsNull = false then SQLQuery_Artikel.FieldByName('Gruppierung').AsString:=UTF8Encode(SQLQueryODBCArtikel.FieldByName('Marke').Value);
           SQLQuery_Artikel.Post;
           SQLQuery_Artikel.ApplyUpdates;
           SQLQuery_Artikel.Refresh;

//           Memo_Status.Text:='nächster Artikel' + chr(13) + Memo_Status.Text;
//           Memo_Status.Refresh;

           SQLQueryODBCArtikel.Next;

           Edit_ArtikelAktuell.Text:=IntToStr(StrToInt(Edit_ArtikelAktuell.Text) + 1);
           Edit_ArtikelAktuell.Refresh;
           frmHaupt.Refresh;
         end;

   Memo_Status.Text:='Beende Artikelverarbeitung.' + chr(13) + Memo_Status.Text;
   Memo_Status.Refresh;

   Memo_Status.Text:='Beginne Verarbeitung von ' + IntToStr(SQLQueryODBCAdressen.RecordCount) + ' Adressen.' + chr(13) + Memo_Status.Text;

   AdressenAktuell := 0;
   RechnungenAktuell := 0;

   Memo_Status.Refresh;
   while SQLQueryODBCAdressen.EOF = false do
         begin
           frmHaupt.Refresh;
           Application.processmessages;
              AdressenAktuell := AdressenAktuell + 1;
              Edit_AdresseAktuell.Text:=IntToStr(AdressenAktuell);
              Edit_AdresseAktuell.Refresh;

              Memo_Status.Text:='Adresse:' + UTF8Encode(SQLQueryODBCAdressen.FieldByName('Name').AsString) + ',' + UTF8Encode(SQLQueryODBCAdressen.FieldByName('Vorname').AsString) + chr(13) + Memo_Status.Text;
              SQLQuery_Adressen.Append;
              SQLQuery_Adressen.FieldByName('Anrede').Value:=SQLQueryODBCAdressen.FieldByName('Anrede').Value;
//              SQLQuery_Adressen.FieldByName('Name').Value:=SQLQueryODBCAdressen.FieldByName('Name').AsString;
              SQLQuery_Adressen.FieldByName('Name').AsString:=UTF8Encode(SQLQueryODBCAdressen.FieldByName('Name').AsString);
              SQLQuery_Adressen.FieldByName('Vorname').AsString:=UTF8Encode(SQLQueryODBCAdressen.FieldByName('Vorname').AsString);
              SQLQuery_Adressen.FieldByName('Strasse').AsString:=UTF8Encode(SQLQueryODBCAdressen.FieldByName(UTF8Decode('Straße')).AsString);
              SQLQuery_Adressen.FieldByName('Plz').Value:=SQLQueryODBCAdressen.FieldByName('Plz').Value;
              SQLQuery_Adressen.FieldByName('Ort').AsString:=UTF8Encode(SQLQueryODBCAdressen.FieldByName('Ort').AsString);
              SQLQuery_Adressen.FieldByName('Telefon1').Value:=SQLQueryODBCAdressen.FieldByName('Telefon').Value;
              SQLQuery_Adressen.FieldByName('Telefon2').Value:=SQLQueryODBCAdressen.FieldByName('Telefon2').Value;
              SQLQuery_Adressen.FieldByName('Handy').Value:=SQLQueryODBCAdressen.FieldByName('Handy').Value;
              SQLQuery_Adressen.FieldByName('Fax').Value:=SQLQueryODBCAdressen.FieldByName('Fax').Value;
//              SQLQuery_Adressen.FieldByName('EMail').Value:=SQLQueryODBCAdressen.FieldByName().Value;
              SQLQuery_Adressen.Post;
              SQLQuery_Adressen.ApplyUpdates;
              SQLQuery_Adressen.Refresh;
              SQLQuery_Adressen.Last;
              IDAdresse := SQLQuery_Adressen.FieldByName('ID').AsInteger;

//              Memo_Status.Text:='Adresse hinzugefügt' + chr(13) + Memo_Status.Text;
//              Memo_Status.Refresh;

              SQLQueryODBCRechnung.Filter:='ID=' + SQLQueryODBCAdressen.FieldByName('ID').AsString;

              while SQLQueryODBCRechnung.EOF = false do
                    begin
                         RechnungenAktuell := RechnungenAktuell + 1;
                         Edit_RechnungAktuell.Text:=IntToStr(RechnungenAktuell);
                         Edit_RechnungAktuell.Refresh;
                         frmHaupt.Refresh;

                         //                         Memo_Status.Text:='Rechnung:' + SQLQueryODBCRechnung.FieldByName('Rechnungsnr').AsString + chr(13) + Memo_Status.Text;
//                         Memo_Status.Refresh;

                         SQLQuery_RechnungGlobal.Append;
                         SQLQuery_RechnungGlobal.FieldByName('IDAdresse').Value:=IDAdresse;
                         SQLQuery_RechnungGlobal.FieldByName('Anrede').Value:=SQLQueryODBCRechnung.FieldByName('Anrede').Value;
                         SQLQuery_RechnungGlobal.FieldByName('Name').Value:=SQLQueryODBCRechnung.FieldByName('Name').Value;
                         SQLQuery_RechnungGlobal.FieldByName('Vorname').Value:=SQLQueryODBCRechnung.FieldByName('Vorname').Value;
                         SQLQuery_RechnungGlobal.FieldByName('Strasse').Value:=SQLQueryODBCRechnung.FieldByName(UTF8Decode('Straße')).Value;
                         SQLQuery_RechnungGlobal.FieldByName('Plz').Value:=SQLQueryODBCRechnung.FieldByName('Plz').Value;
                         SQLQuery_RechnungGlobal.FieldByName('Telefon1').Value:=SQLQueryODBCRechnung.FieldByName('Telefon').Value;
                         SQLQuery_RechnungGlobal.FieldByName('Fax').Value:=SQLQueryODBCRechnung.FieldByName('Fax').Value;
                         SQLQuery_RechnungGlobal.FieldByName('Art').Value:=SQLQueryODBCRechnung.FieldByName('Art').Value;
                         SQLQuery_RechnungGlobal.FieldByName('Quartal').Value:=SQLQueryODBCRechnung.FieldByName('Quartal').Value;
                         SQLQuery_RechnungGlobal.FieldByName('Jahr').Value:=SQLQueryODBCRechnung.FieldByName('Jahr').Value;
                         TryStrToDate(SQLQueryODBCRechnung.FieldByName('Datum').AsString, Datum);
                         SQLQuery_RechnungGlobal.FieldByName('Datum').Value:=Datum;
                         SQLQuery_RechnungGlobal.FieldByName('Steuersatz').Value:=SQLQueryODBCRechnung.FieldByName('Steuer').Value;
                         SQLQuery_RechnungGlobal.FieldByName('MwSt').Value:=SQLQueryODBCRechnung.FieldByName('MwSt').Value;
                         SQLQuery_RechnungGlobal.FieldByName('JahresNummer').Value:=SQLQueryODBCRechnung.FieldByName('JahresNummer').Value;
                         SQLQuery_RechnungGlobal.FieldByName('Rechnungsnr').Value:=SQLQueryODBCRechnung.FieldByName('RechnungsJahresNr').Value;
                         if SQLQueryODBCRechnung.FieldByName('inklMwSt').AsBoolean = true then
                            begin
                                 SQLQuery_RechnungGlobal.FieldByName('Gesamtpreis_Brutto').Value:=SQLQueryODBCRechnung.FieldByName('Gesamtpreis').Value;
                                 SQLQuery_RechnungGlobal.FieldByName('Gesamtpreis_Netto').Value:=FloatToStrF((StrToFloat(StringReplace(SQLQueryODBCRechnung.FieldByName('Gesamtpreis').AsString,',',DecimalSeparator,[rfReplaceAll])) / (1 + (StrToFloat(StringReplace(SQLQueryODBCRechnung.FieldByName('Steuer').AsString,',',DecimalSeparator,[rfReplaceAll])) / 100))),ffNumber,2,2);
                            end
                         else
                            begin
                                 SQLQuery_RechnungGlobal.FieldByName('Gesamtpreis_Brutto').Value:=FloatToStrF((StrToFloat(StringReplace(SQLQueryODBCRechnung.FieldByName('Gesamtpreis').AsString,',',DecimalSeparator,[rfReplaceAll])) * (1 + (StrToFloat(StringReplace(SQLQueryODBCRechnung.FieldByName('Steuer').AsString,',',DecimalSeparator,[rfReplaceAll])) / 100))), ffNumber,2,2);
                                 SQLQuery_RechnungGlobal.FieldByName('Gesamtpreis_Netto').Value:=SQLQueryODBCRechnung.FieldByName('Gesamtpreis').Value;
                            end;
//                            if SQLQueryODBCRechnung.FieldByName('inklMwSt').AsBoolean = true then
//                               begin
//                                    SQLQuery_RechnungGlobal.FieldByName('inklMwSt').Value:=1;
//                               end
//                            else
//                                begin
//                                  SQLQuery_RechnungGlobal.FieldByName('inklMwSt').Value:=0;
//                               end;
                         SQLQuery_RechnungGlobal.FieldByName('geloescht').Value:=SQLQueryODBCRechnung.FieldByName(UTF8Decode('gelöscht')).Value;
//                         SQLQuery_RechnungGlobal.FieldByName('QuartalNummer').Value:=SQLQueryODBCRechnung.FieldByName('').Value;
//                         SQLQuery_RechnungGlobal.FieldByName('MonatNummer').Value:=SQLQueryODBCRechnung.FieldByName('').Value;
//                         SQLQuery_RechnungGlobal.FieldByName('Monat').Value:=SQLQueryODBCRechnung.FieldByName('').Value;
                         SQLQuery_RechnungGlobal.Post;
                         SQLQuery_RechnungGlobal.ApplyUpdates;
                         SQLQuery_RechnungGlobal.Refresh;
                         SQLQuery_RechnungGlobal.Last;
                         IDRechnungGlobal := SQLQuery_RechnungGlobal.FieldByName('ID').AsInteger;
//                         Memo_Status.Text:='Rechnung:' + SQLQuery_RechnungGlobal.FieldByName('ID').AsString + ' erstellt.' + chr(13) + Memo_Status.Text;
//                         Memo_Status.Refresh;
                         for i:=0 to 24 do
                             begin
                               frmHaupt.Refresh;
                                  if (SQLQueryODBCRechnung.FieldByName('Anzahl' + IntToStr(i)).AsString='') and (SQLQueryODBCRechnung.FieldByName('Einheit' + IntToStr(i)).AsString='') and (SQLQueryODBCRechnung.FieldByName('Artikel' + IntToStr(i)).AsString='') and (SQLQueryODBCRechnung.FieldByName(UTF8Decode('Stückpreis') + IntToStr(i)).AsString='') and (SQLQueryODBCRechnung.FieldByName('Gesamt' + IntToStr(i)).AsString='') then
                                     begin

                                     end
                                  else
                                      begin
//                                           Memo_Status.Text:='Rechnungsdetail Feldzahl:' + IntToStr(i) + chr(13) + Memo_Status.Text;
//                                           Memo_Status.Refresh;
                                           SQLQuery_RechnungDetail.Append;
                                           SQLQuery_RechnungDetail.FieldByName('IDRechnungGlobal').Value:=IDRechnungGlobal;
                                           if SQLQueryODBCRechnung.FieldByName('Anzahl' + IntToStr(i)).IsNull = false then SQLQuery_RechnungDetail.FieldByName('Anzahl').Value:=SQLQueryODBCRechnung.FieldByName('Anzahl' + IntToStr(i)).Value;
                                           if SQLQueryODBCRechnung.FieldByName('Einheit' + IntToStr(i)).IsNull = false then SQLQuery_RechnungDetail.FieldByName('Einheit').AsString:=UTF8Encode(SQLQueryODBCRechnung.FieldByName('Einheit' + IntToStr(i)).Value);
                                           if SQLQueryODBCRechnung.FieldByName('Artikel' + IntToStr(i)).IsNull = false then SQLQuery_RechnungDetail.FieldByName('Artikel').AsString:=UTF8Encode(SQLQueryODBCRechnung.FieldByName('Artikel' + IntToStr(i)).Value);
                                           if SQLQueryODBCRechnung.FieldByName(UTF8Decode('Stückpreis') + IntToStr(i)).IsNull = false then
                                              begin
                                                   if SQLQueryODBCRechnung.FieldByName('inklMwSt').AsBoolean = true then
                                                      begin
                                                           //SQLQuery_RechnungGlobal.FieldByName('Gesamtpreis_Netto').Value:=FloatToStrF((StrToFloat(StringReplace(SQLQueryODBCRechnung.FieldByName('Gesamtpreis').AsString,',',DecimalSeparator,[rfReplaceAll])) / (1 + (StrToFloat(StringReplace(SQLQueryODBCRechnung.FieldByName('MwSt').AsString,',',DecimalSeparator,[rfReplaceAll])) / 100))),ffNumber,2,2);
                                                           //   SQLQuery_RechnungGlobal.FieldByName('Gesamtpreis_Brutto').Value:=FloatToStrF((StrToFloat(StringReplace(SQLQueryODBCRechnung.FieldByName('Gesamtpreis').AsString,',',DecimalSeparator,[rfReplaceAll])) * (1 + (StrToFloat(StringReplace(SQLQueryODBCRechnung.FieldByName('MwSt').AsString,',',DecimalSeparator,[rfReplaceAll])) / 100))), ffNumber,2,2);

                                                           SQLQuery_RechnungDetail.FieldByName('Stueckpreis_Brutto').Value:=SQLQueryODBCRechnung.FieldByName(UTF8Decode('Stückpreis') + IntToStr(i)).Value;
                                                           SQLQuery_RechnungDetail.FieldByName('Stueckpreis_Netto').Value:=FloatToStrF((StrToFloat(StringReplace(SQLQueryODBCRechnung.FieldByName(UTF8Decode('Stückpreis') + IntToStr(i)).AsString,',',DecimalSeparator,[rfReplaceAll])) / (1 + (StrToFloat(StringReplace(SQLQueryODBCRechnung.FieldByName('Steuer').AsString,',',DecimalSeparator,[rfReplaceAll])) / 100))),ffNumber,2,2);
                                                           //SQLQuery_RechnungDetail.FieldByName('Stueckpreis_Netto').Value:=FloatToStrF((StrToFloat(StringReplace(SQLQueryODBCRechnung.FieldByName(UTF8Decode('Stückpreis') + IntToStr(i)).AsString,',',DecimalSeparator,[rfReplaceAll])) - (StrToFloat(StringReplace(SQLQueryODBCRechnung.FieldByName(UTF8Decode('Stückpreis') + IntToStr(i)).AsString,',',DecimalSeparator,[rfReplaceAll])) * (StrToFloat(StringReplace(SQLQueryODBCRechnung.FieldByName('MwSt').AsString,',',DecimalSeparator,[rfReplaceAll])) / 100))),ffNumber,2,2);
                                                           if SQLQueryODBCRechnung.FieldByName('Gesamt' + IntToStr(i)).IsNull = false then
                                                              begin
                                                                   SQLQuery_RechnungDetail.FieldByName('Gesamt_Netto').Value:=FloatToStrF((StrToFloat(StringReplace(SQLQueryODBCRechnung.FieldByName('Gesamt' + IntToStr(i)).AsString,',',DecimalSeparator,[rfReplaceAll])) / (1 + (StrToFloat(StringReplace(SQLQueryODBCRechnung.FieldByName('Steuer').AsString,',',DecimalSeparator,[rfReplaceAll])) / 100))),ffNumber,2,2);
//                                                                   SQLQuery_RechnungDetail.FieldByName('Gesamt_Netto').Value:=FloatToStrF((StrToFloat(StringReplace(SQLQueryODBCRechnung.FieldByName('Gesamt' + IntToStr(i)).AsString,',',DecimalSeparator,[rfReplaceAll])) - (StrToFloat(StringReplace(SQLQueryODBCRechnung.FieldByName('Gesamt' + IntToStr(i)).AsString,',',DecimalSeparator,[rfReplaceAll])) * (StrToFloat(StringReplace(SQLQueryODBCRechnung.FieldByName('MwSt').AsString,',',DecimalSeparator,[rfReplaceAll])) / 100))),ffNumber,2,2);
                                                                   SQLQuery_RechnungDetail.FieldByName('Gesamt_Brutto').Value:=SQLQueryODBCRechnung.FieldByName('Gesamt' + IntToStr(i)).Value;
                                                              end;
                                                      end
                                                   else
                                                       begin
//                                                            SQLQuery_RechnungDetail.FieldByName('Stueckpreis_Brutto').Value:=FloatToStrF((StrToFloat(StringReplace(SQLQueryODBCRechnung.FieldByName(UTF8Decode('Stückpreis') + IntToStr(i)).AsString,',',DecimalSeparator,[rfReplaceAll])) * (1 + (StrToFloat(StringReplace(SQLQueryODBCRechnung.FieldByName('MwSt').AsString,',',DecimalSeparator,[rfReplaceAll])) / 100))),ffNumber,2,2);
                                                            SQLQuery_RechnungDetail.FieldByName('Stueckpreis_Brutto').Value:=FloatToStrF((StrToFloat(StringReplace(SQLQueryODBCRechnung.FieldByName(UTF8Decode('Stückpreis') + IntToStr(i)).AsString,',',DecimalSeparator,[rfReplaceAll])) * (1 + (StrToFloat(StringReplace(SQLQueryODBCRechnung.FieldByName('MwSt').AsString,',',DecimalSeparator,[rfReplaceAll])) / 100))), ffNumber,2,2);
                                                            SQLQuery_RechnungDetail.FieldByName('Stueckpreis_Netto').Value:=SQLQueryODBCRechnung.FieldByName(UTF8Decode('Stückpreis') + IntToStr(i)).Value;
                                                            if SQLQueryODBCRechnung.FieldByName('Gesamt' + IntToStr(i)).IsNull = false then
                                                               begin
                                                                    SQLQuery_RechnungDetail.FieldByName('Gesamt_Netto').Value:=SQLQueryODBCRechnung.FieldByName('Gesamt' + IntToStr(i)).Value;
//                                                                    SQLQuery_RechnungDetail.FieldByName('Gesamt_Brutto').Value:=FloatToStrF((StrToFloat(StringReplace(SQLQueryODBCRechnung.FieldByName('Gesamt' + IntToStr(i)).AsString,',',DecimalSeparator,[rfReplaceAll])) - StrToFloat(StringReplace(SQLQueryODBCRechnung.FieldByName('Gesamt' + IntToStr(i)).AsString,',',DecimalSeparator,[rfReplaceAll])) * (1 + (StrToFloat(StringReplace(SQLQueryODBCRechnung.FieldByName('MwSt').AsString,',',DecimalSeparator,[rfReplaceAll])) / 100))),ffNumber,2,2);
                                                                    SQLQuery_RechnungDetail.FieldByName('Gesamt_Brutto').Value:=FloatToStrF((StrToFloat(StringReplace(SQLQueryODBCRechnung.FieldByName('Gesamt' + IntToStr(i)).AsString,',',DecimalSeparator,[rfReplaceAll])) * (1 + (StrToFloat(StringReplace(SQLQueryODBCRechnung.FieldByName('MwSt').AsString,',',DecimalSeparator,[rfReplaceAll])) / 100))), ffNumber,2,2);
                                                               end;
                                                       end;
                                              end;
//                                           if SQLQueryODBCRechnung.FieldByName('Gesamt' + IntToStr(i)).IsNull = false then SQLQuery_RechnungDetail.FieldByName('Gesamt').Value:=SQLQueryODBCRechnung.FieldByName('Gesamt' + IntToStr(i)).Value;
                                           SQLQuery_RechnungDetail.Post;
                                           SQLQuery_RechnungDetail.ApplyUpdates;
                                           SQLQuery_RechnungDetail.Refresh;
                                      end;

                             end;
                         SQLQueryODBCRechnung.Next;
                    end;
              SQLQueryODBCAdressen.Next;
              frmHaupt.Refresh;
              Application.processmessages;
//              Memo_Status.Refresh;
         end;

   SQLTransaction.Commit;

   SQLQueryODBCAdressen.Close;
   SQLQueryODBCRechnung.Close;
   SQLQueryODBCArtikel.Close;

   SQLQuery_Adressen.Close;
   SQLQuery_RechnungGlobal.Close;
   SQLQuery_RechnungDetail.Close;
   SQLQuery_Artikel.Close;

   FileNameEdit_ODBC.FileName := '';
   FileNameEdit_SQLite.FileName := '';

   Memo_Status.Text:='Konvertierung beendet.' + chr(13) + Memo_Status.Text;
end;

procedure TfrmHaupt.FileNameEdit_SQLiteChange(Sender: TObject);
begin

end;

procedure TfrmHaupt.FormCreate(Sender: TObject);
begin
end;

procedure TfrmHaupt.FormShow(Sender: TObject);
begin
//    FileNameEdit_SQLite. *.db
   FileNameEdit_SQLite.Filter:='SQLite Datenbank|*.db3';
   FileNameEdit_ODBC.Filter:='MSAccess Datenbank|*.mdb;*.accdb';
   Combobox_ODBC.Items.Add( 'Microsoft Access Driver (*.mdb)');
   Combobox_ODBC.Items.Add('Microsoft Access Driver (*.mdb, *.accdb)');
   Combobox_ODBC.ItemIndex:=0;
   Memo_Status.Text:='Programm bereit.';

   //   driver := 'Microsoft Access Driver (*.mdb, *.accdb)';

end;

procedure TfrmHaupt.SQLQueryODBCAdressenAfterOpen(DataSet: TDataSet);
var
  i : Integer;
begin
for i:=0 to DataSet.Fields.Count-1 do
   begin
     if (DataSet.Fields[i].DataType=ftString) or (DataSet.Fields[i].DataType=ftMemo) or (DataSet.Fields[i].DataType=ftWideMemo) or (DataSet.Fields[i].DataType=ftFmtMemo) or (DataSet.Fields[i].DataType=ftWideString)  or (DataSet.Fields[i].DataType=ftFixedChar)  or (DataSet.Fields[i].DataType=ftFixedWideChar) or (DataSet.Fields[i].DataType=ftUnknown) or (DataSet.Fields[i].DataType=ftVariant) then
       begin
         DataSet.Fields[i].OnGetText:=@Text_von_DB_umwandeln;
         DataSet.Fields[i].OnSetText:=@Text_nach_DB_umwandeln;
       end;
   end;
end;

procedure TfrmHaupt.Text_von_DB_umwandeln(Sender: TField; var aText: string; DisplayText: BOOLEAN);
begin
  if Sender.AsString <> '' then
     begin
           aText := UTF8Encode(Sender.AsVariant);
     end;
end;

procedure TfrmHaupt.Text_nach_DB_umwandeln(Sender: TField; const aText: string);
begin
  if aText <> '' then
     begin
          Sender.Value := UTF8Decode(aText);
     end;
end;

end.

